<?php
/*
Plugin Name: WP-Cuf&oacute;n
Plugin URI: http://www.tobias-battenberg.de/wp-cufon
Description: Enables Cuf&oacute;n font-replacement in WordPress - After installation you only have to put your generated font-files in the <em>/pluginswp-cufon/fonts/</em> directory. Go to the <a href='themes.php?page=wp-cufon.php'>Settings Page</a> to add your replacement scripts.
Version: 1.3
Author: Tobias Battenberg
Author URI: http://www.tobias-battenberg.de
*/
?>
<?php

function wpcufon_jquery_init() {
    // jQuery Enabler
	if(get_option("cufon_jquery") == "1"){
    	wp_enqueue_script( 'jquery' );
    }            
}    
 
add_action('init', wpcufon_jquery_init);



function wpcufon_init() {
	
	$url = get_bloginfo('wpurl');

?>
    
    <!-- WP-Cufon Plugin START  -->
    <script type="text/javascript" src="<?php echo $url; ?>/wp-content/plugins/wp-cufon/js/cufon-yui.js"></script>
            
    <?php    
    foreach (glob("wp-content/plugins/wp-cufon/fonts/*.js") as $filename) {
	?>
    <!-- WP-Cufon Fonts found  -->
	<script src="<?php echo $url; ?>/<?php echo $filename; ?>" type="text/javascript"></script>
	<?php
    }    
    ?>        
    <!-- WP-Cufon Plugin Replacements  -->
	<script type="text/javascript">
        <?php echo stripslashes(get_option("cufon_replacement_script")); ?>
    </script>
     <!-- WP-Cufon END  -->
        
<?php } // end function
add_action('wp_head', 'wpcufon_init');


// add js.tag for better ie6/7 compatibility before </body> ends!
// Note: This step will hopefully become obsolete in the future.
function wp_cufon_ietag() {
	?>
    <!-- WP-Cufon Plugin (ie6/7 compatibility tag) before </body> ends  -->
    <script type="text/javascript"> Cufon.now(); </script>
<?php }
add_action('wp_footer', 'wp_cufon_ietag');



/*

ADMIN

*/

add_action('admin_menu', 'wpcufon_config_page');

function wpcufon_config_page() {
	if ( function_exists('add_submenu_page') )
		add_submenu_page('themes.php', __('WP-Cuf&oacute;n'), __('Cuf&oacute;n'), '8', 'wp-cufon.php', 'wpcufon_settings_page');
}


function wpcufon_settings_page() {
?>	
	<!-- Messages -->
    <?php if ( !empty($_POST ) ) : ?>
	    <div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div>
    <?php endif; ?>

    <div class="wrap">
    <h2>Cuf&oacute;n Administration</h2>
    
    <div class="narrow">
    <p>
    Cuf&oacute;n aims to become a worthy alternative to sIFR, which despite its merits still remains painfully tricky to set up and use.
    </p>
    <p>
    This Plugin enables Cuf&oacute;n in your WordPress Blog.<br />
    For more information about Cuf&oacute;n please have look at <a href="http://wiki.github.com/sorccu/cufon" target="_blank">http://wiki.github.com/sorccu/cufon</a>.
    </p>	
    <h3>Generate & activate the fonts</h3>
    <small>First you have to convert your font-file (.ttf, .otf) into a Cuf&oacute;n compatible format.<br />You can do this by using Cuf&oacute;n's own generator at <a href="http://cufon.shoqolate.com/generate/" target="_blank">http://cufon.shoqolate.com/generate/</a><br /><br />In the next step you must upload your <em>.font.js</em> font-files to <span class="code">/wp-content/plugins/wp-cufon/fonts/</span><br />The Plugin will recognize your uploaded fonts and activate them.</small>
    <?php wpcufon_set_font(); ?>
    <br />
    <h3>Set the font-replacements</h3>
    <small>
        <b>Easy Example:</b><br />
        <span class="code">
            Cufon.replace('h1', {<br />
            &nbsp;&nbsp;&nbsp;&nbsp;color: '-linear-gradient(red, #fff, #23d559, rgb(0, 0, 0))'<br />
            });
        </span>
        
        <br /><br />
        
        <b>Replace with different fonts:</b><br />
        <span class="code">
            Cufon.replace('h1', { fontFamily: 'Frutiger LT Std' });<br />
            Cufon.replace('h2', { fontFamily: 'Myriad Pro' });
        </span>
        
        <br /><br />
        
        <b>Access via JavaScript frameworks: (e.g. jQuery needs to be enabled)</b><br />
        <span class="code">
            Cufon.replace('#your_div_id > h1:first-child');<br />
            Cufon.replace('#your_div_id a');<br />
            Cufon.replace('#your_div_id', { fontFamily: 'FontName-Medium' });
        </span>
        
        <br /><br />
        
        &raquo; <a href="http://wiki.github.com/sorccu/cufon/styling" target="_blank">Get more styling hints</a>
    </small>
    <?php wpcufon_set_font_replacements(); ?>
    
    </div><!-- narrow -->   
    </div><!-- wrap -->

<?php
}


function wpcufon_set_font() {	
	?>
    <p><strong>The plugin automatically found (and activated) these font-files for Cuf&oacute;n:</strong>
    </p>	
    <p>
    <?php
    foreach (glob("../wp-content/plugins/wp-cufon/fonts/*.js") as $filename) {
		
		// delete path from filename (looks better)
		$filename = str_replace("../wp-content/plugins/wp-cufon/fonts/", "", $filename);		
		?>
		<input type="checkbox" checked="checked" disabled="disabled" /> <input type="text" disabled="disabled" value="<? echo $filename; ?>" size="30" /><br />
		<?php
	}
    ?>
    
    </p>
    
	<?php
}



/*
	FONT REPLACEMENTS (text src)
*/

$cufon_replacement_script = stripslashes(get_option('cufon_replacement_script'));
 
if ('saveDB' == $_POST['action']) {
	update_option("cufon_replacement_script",stripslashes($_POST['cufon_replacement_script']));
	update_option("cufon_jquery",$_POST['cufon_jquery']);
}

$first_value = "Cufon.replace('h1');";
add_option("cufon_replacement_script",stripslashes($first_value));
add_option("cufon_jquery","");

function wpcufon_set_font_replacements(){
?>
   <strong> <p>Please enter your source for the replacements:</p></strong>
    
<form name="form1" method="post" action="">
	<textarea class="code" name="cufon_replacement_script" rows="12" cols="60"><?php echo stripslashes(get_option("cufon_replacement_script"));?></textarea>
    <p><em><strong>Hint:</strong> Set all the other font-details in your style.css file -  Cuf&oacute;n will recognize them.</em></p>
    
    <?php $jquery_enabled = get_option("cufon_jquery"); ?>
    <p><label><input name="cufon_jquery" type="checkbox" value="1" <?php if(get_option("cufon_jquery") == "1"){ echo"checked"; }?>  /> Enable jQuery <small>(WP-Cuf&oacute;n will do it only if it's necessary)</small></label></p>
    
    <p><input type="submit" value=" Update Settings " /></p>
    <input name="action" value="saveDB" type="hidden" />
</form>
    
<?php
}


?>